<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading">
      <h2>Wprowadź nazwę użytkownika</h2>
      <form @submit.prevent="submitForm" class="formStyling">
        <div class="form-control" :class="{ invalid: !username.isValid }">
          <label for="topic">Nazwa użytkownika</label>
          <input
            type="text"
            id="username"
            v-model.trim="username.val"
            @blur="clearValidity('username')"
          />
          <p v-if="!username.isValid">Uzupełnij nazwę użytkownika.</p>
        </div>
        <div class="button">
          <base-button>Zatwierdź nazwę użytkownika</base-button>
        </div>
      </form>
    </div>
  </base-card>
</template>

<script setup>
import { ref, defineProps } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const props = defineProps(["id"]);

const username = ref({
  val: "",
  isValid: true,
});

const formIsValid = ref(true);
const error = ref(null);
const isLoading = ref(false);
const report = ref(null);

const store = useStore();
const router = useRouter();

function handleError() {
  error.value = null;
  router.replace("/reports");
}

function clearValidity(input) {
  this[input].isValid = true;
}

function validateForm() {
  formIsValid.value = true;
  if (username.value.val === "") {
    username.value.isValid = false;
    formIsValid.value = false;
  }
}

async function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  isLoading.value = true;
  try {
    await store.dispatch("setFirstRead", {
      id: report.value["uuId"],
      user: username.value.val,
    });
    await router.replace("/reports/" + props.id);
  } catch (er) {
    error.value = er.message || "Nie udało się zapisać użytkownika.";
  }
  isLoading.value = false;
}

report.value = store.getters.reports.find(
  (report) => report["id"] === props.id
);
if (report.value === undefined) {
  router.replace("/notFound");
} else if (report.value["isRead"] === true) {
  router.replace("/reports");
}
</script>
